// maybe like funcs..idk optim catch key
/*
check({
  title: () => stringField(''),
  amount: () => intField(''),
});*/
export function check(objWithFunc) {
    const kv = {};
    const keys = Object.keys(objWithFunc);
    for(const key of keys) {
        try {
          objWithFunc[key]();
          kv[key] = objWithFunc[key]();
        } catch(err) {
            throw new Error(key + ' is ' + String(err).replace('Error: ','').toLowerCase());
        }
    }
  return kv;
    
}
//listField({}, {name:'somename'});
//booleanField(false);
export function listField(inputs,extraOptions={}) { 
        if( !Array.isArray(inputs)) {
             if('name' in extraOptions) {
                 throw new Error(extraOptions.name + ' is not a valid list');
             } else {
                 throw new Error('Not a valid list');
             }
           }
  
  return inputs;
}
// listField([1,2,3]);
// listField({hi:1});
// listField(2);

//const { a, b } = stringFields({ a:'1',b:'2'});
//const [ c,d ] = ['nice', 'nice2'];
//const { e,f } = {e:'n', 'f':'sd'};
//stringFields(['2','1']);
export function stringField(inputs,extraOptions={}) { 
     if(typeof(inputs) !== 'string' || inputs instanceof String){
         if('name' in extraOptions) {
                 throw new Error(extraOptions.name + ' is not a valid string');
             } else {
             throw new Error('Not a valid string');
             }
           }
  
      return inputs;
}
//stringField('2');
//stringField(String('2'));
//stringField([1,2,3]); // should throw err
//stringField({hi:1}); // should throw err
//stringField(2); // should throw err

export function objectField(inputs,extraOptions={}) { 
        if( !(inputs instanceof Object) || !(!Array.isArray(inputs))) {
          if('name' in extraOptions) {
                 throw new Error(extraOptions.name + ' is not a valid Object');
             } else {
             throw new Error('Not a valid Object');
             }
           }
  
  return inputs;
}

//console.log('1',intField(1));
//console.log('1',intField('1'));
//console.log('1?',intField(parseInt('1.1234')));

export function intField(inputs,extraOptions={}) {
       function _isNumeric(n) { 
            return !isNaN(parseFloat(n)) && isFinite(n); 
      }
      const number = parseInt(inputs);
      if(!_isNumeric(number)) {
        if('name' in extraOptions) {
                 throw new Error(extraOptions.name + ' is not a valid number');
             } else {
          throw new Error('Not a valid number');
             }
      }
      if(inputs !== number) {
        if('name' in extraOptions) {
                 throw new Error(extraOptions.name + ' is not a valid int type');
             } else {
          throw new Error('Not a valid int type');
             }
      }

      return inputs;
}
export function booleanField(inputs,extraOptions={}) { 
        if(inputs !== true && inputs !== false) {
          if('name' in extraOptions) {
                 throw new Error(extraOptions.name + ' is not a valid boolean');
             } else {
             throw new Error('Not a valid boolean');
             }
           }
  
  return inputs;
}
export function emailField(inputs,extraOptions={}) { 
     if(typeof(inputs) !== 'string' || ( !(inputs.includes('@') && inputs.includes('.'))) ){
       if('name' in extraOptions) {
                 throw new Error(extraOptions.name + ' is not a valid email');
             } else {
             throw new Error('Not a valid email');
             }
           }
  
      return inputs;
}

/*
// test: Simplest Possible Validation, Keeping Things Primitive, Untouched.
console.log(objectField({hello:'world'})); // { hello: 'world' }
console.log(emailField('email@hello.com')); // email@hello.com
console.log(booleanField(true)); // true

//console.log(objectField([{hello:'world'}])); // throws error
// console.log(booleanField('true')); throws error
//console.log(booleanField(1)); // throws error

// Bonus: even nice for deeper validation
console.log(objectField({hello:objectField({hello:'world2'})})); // { hello: { hello: 'world2' } }
console.log(objectField({hello:emailField('email@hello2.com')})); // { hello: 'email@hello2.com' }
console.log(objectField({hello:booleanField(true)})); // { hello: { hello: true } }
//*/



// notes to self:
// the downside is that you sort of can't check for Class names.. 
// upside is that you have actually valid objects..
// major downside is that you'd need to iterate over every type to see which it is..
// like when used in orm.. you can still I mean use the model.. like stringField().. then use this to 'escape it'.. 
// idk.. maybe it's the solution.. just keep custom class names out of it..
// before send.. you can use the functions.. keep primitives.. 
// after you can receive inputs.. use functions.. keep primitives.. yeah..
// yeah maybe actually just what I need..
// idk when you'd need a class, or instance check or something..
// like bigger vision would just be to use this for all inputs.. everywhere.. every function sort of..
// not use weird classes for it.. just this.. keeping primitives.. or objects or array clean.. but verify first..